'use strict';
angular.module('beamng.apps')
.directive('mintacho', ['logger', function (logger) {
  return {
    template:
        '<object style="width:100%; height:100%; box-sizing:border-box; pointer-events: none" type="image/svg+xml" data="/ui/modules/apps/MinTacho/tacho.svg"></object>',
    replace: true,
    restrict: 'EA',
    link: function (scope, element, attrs) {

      element.css({transition:'opacity 0.3s ease'})
      let visible = false;
      element.on('load', function () {
        var svg = element[0].contentDocument

        scope.$on('streamsUpdate', function (event, streams) { 
          if (svg.update(streams)) {
            if(!visible) {
              element[0].style.opacity = 1
              visible = true
            }
          } else {
            if(visible) {
              element[0].style.opacity = 0
              visible = false
            }
          }
        })

        scope.$on('VehicleChange', function() { if(svg.vehicleChanged) svg.vehicleChanged } );
        scope.$on('VehicleFocusChanged', function (event, data) {
          if(data.mode == 1 && svg && svg.vehicleChanged) {
             svg.vehicleChanged();
          }
        });

        svg.wireThroughUnitSystem((val, func) => UiUnits[func](val))

        StreamsManager.add(svg.getStreams())
        scope.$on('$destroy', function () {
          StreamsManager.remove(svg.getStreams())
        })
      })
    }
  }
}])